/*
  ShieldOffline.c - Keep the shield offline while its parent is "destroyed".

  Jason Hood, 23 August, 2010.

  Build (VC 6):
	rc ShieldOffline.rc
	cl /nologo /W3 /Gf /Ox /MD /LD ShieldOffline.c ShieldOffline.res

  Install:
    Copy SHIELDOFFLINE.DLL to the EXE directory and add it to the [Libraries]
    section of EXE\dacom.ini.  Requires and assumes v1.1.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define NAKED	__declspec(naked)


#define ADDR_ACTIVE ((PDWORD)0x639d510) // CEShield::IsActive


DWORD dummy;
#define ProtectW( addr, size ) \
  VirtualProtect( addr, size, PAGE_READWRITE, &dummy );


DWORD old_addr;

NAKED
void Active_Hook( void )
{
  __asm {
	mov	eax, [ecx+4]		// CSolar
	cmp	dword ptr [eax+0xB8], 0 // get_hit_pts
	je	inactive
	jmp	old_addr
  inactive:
	mov	al, 0
	ret
  }
}


void Patch()
{
  ProtectW( ADDR_ACTIVE, 4 );

  old_addr = *ADDR_ACTIVE;
  *ADDR_ACTIVE = (DWORD)Active_Hook;
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH)
    Patch();

  return TRUE;
}
